#include "namewidget.h"
#include "kapp.h"
#include <iostream.h>
#include <strstream.h>

#define ktr klocale->translate 

namewidget::namewidget(QWidget *parent, const char *name, TodoList *tdlist )
{
	parent=parent;name=name; // i hate compiler warnings...
 	initMetaObject();
	initLayout();
	setCaption( ktr ("Krabber - hack in the track information") );

	todolist_n = tdlist;
	todolist_nr = 1;

	connect( QPushButton_Help, SIGNAL(clicked()), SLOT( invokeHelp()) );
	connect( QPushButton_Finish, SIGNAL(clicked()), SLOT(finish()) );
	connect( QPushButton_p_file, SIGNAL(clicked()), SLOT(previous_file()) );
	connect( QPushButton_n_file, SIGNAL(clicked()), SLOT(next_file()) );
	connect( QLineEdit_title, SIGNAL(returnPressed()), SLOT(next_file()) );
	connect( QLineEdit_title, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QLineEdit_album, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QLineEdit_group, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QLineEdit_file_1, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QLineEdit_file_2, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QLineEdit_file_3, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QLineEdit_file_4, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
	connect( QComboBox_file_1, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
	connect( QComboBox_file_2, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
	connect( QComboBox_file_3, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
	connect( QComboBox_file_4, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
	update_view();
	update_view_filename("");
	QLineEdit_group->setFocus();
	resize( 710,290 );
	setFixedSize( 710, 290 );
};

namewidget::~namewidget() 
{
	;
}

void namewidget::update_view_filename(const char *temp)
{
	QString temp2;
	if ( !init )
	{
		todolist_n->group[ todolist_nr ] = QLineEdit_group->text();
		todolist_n->album[ todolist_nr ] = QLineEdit_album->text();
		todolist_n->title[ todolist_nr ] = QLineEdit_title->text();
		temp2 = ktr ( "File name: " );
		QLabel_filename->setText( temp2 + update_filename( todolist_nr ) );
	};
};
void namewidget::update_view_filename( int z )
{
	z = z ; // I hate compiler warnings
	QString temp2;
	if ( !init )
	{
		todolist_n->group[ todolist_nr ] = QLineEdit_group->text();
		todolist_n->album[ todolist_nr ] = QLineEdit_album->text();
		todolist_n->title[ todolist_nr ] = QLineEdit_title->text();
		temp2 = ktr ( "File name: " );
		QLabel_filename->setText( temp2 + update_filename( todolist_nr ) );
	};
};
QString namewidget::update_filename ( unsigned int nr )
{
	QString temp;

	temp  = update_filename_sub( QComboBox_file_1->currentItem(), nr );
	temp += QLineEdit_file_1->text();
	temp += update_filename_sub( QComboBox_file_2->currentItem(), nr );
	temp += QLineEdit_file_2->text();
	temp += update_filename_sub( QComboBox_file_3->currentItem(), nr );
	temp += QLineEdit_file_3->text();
	temp += update_filename_sub( QComboBox_file_4->currentItem(), nr );
	temp += QLineEdit_file_4->text();

	return temp;
}
QString namewidget::update_filename_sub( unsigned int id, unsigned int nr)
{
	QString temp;
	char temp2[10];
	temp = "";
	if ( id == 1 )	
	{
		ostrstream(temp2, 10) << nr << ends;
		temp = temp2;
		if (  nr  < 10 )
			temp = "0" + temp;
	};
	if ( id == 2 )	
	{
		ostrstream(temp2, 10) << todolist_n->tracknumber[ nr ] << ends;
		temp = temp2;
		if ( todolist_n->tracknumber[ nr ] < 10 )
			temp = "0" + temp;
	};
	if ( id == 3 )
		temp = todolist_n->group[ nr ];
	if ( id == 4 )
		temp = todolist_n->album[ nr ];
	if ( id == 5 )
		temp = todolist_n->year[ nr ];
	if ( id == 6 )
		temp = todolist_n->title[ nr ];

	return temp;
}
void namewidget::next_file()
{
	save_input();
	if ( todolist_nr == todolist_n->tracks )
		todolist_nr = 1;
	else
		todolist_nr++;
	update_view();
	update_view_filename("");
};
void namewidget::previous_file()
{
	save_input();
	if ( todolist_nr == 1 )
		todolist_nr = todolist_n->tracks;
	else
		todolist_nr--;
	update_view();
	update_view_filename("");
};
void namewidget::update_view()
{
	QString temp;
	char temp2[10];
//	unsigned int size;

	init = TRUE;

	if ( todolist_n->type[ todolist_nr ] == 1 )
	{
		ostrstream(temp2, 10) << todolist_n->tracknumber[ todolist_nr ] << ends;
		temp = temp2;
		if ( todolist_n->tracknumber[ todolist_nr ] < 10 )
			temp = "0" + temp;
	
		temp += ". Track auf " + todolist_n->device[ todolist_nr ] + " : " ;
		ostrstream(temp2, 10) << todolist_n->nodes[ todolist_nr ] / 512 <<ends;
		temp += temp2 ;
		temp += "MB";
	};
	if ( todolist_n->type[ todolist_nr ] > 1 &&  todolist_n->type[ todolist_nr ] < 2 )
	{
		temp = todolist_n->device[ todolist_nr ] + " : " ;
		ostrstream(temp2, 10) << todolist_n->nodes[ todolist_nr ] * 2340 <<ends;
		temp += temp2 ;
		temp += "MB";
	};
	QLabel_FileInfo->setText( temp );
	QLineEdit_title->setText( todolist_n->title[ todolist_nr ] );
	if ( todolist_n->group[todolist_nr] != "" ) QLineEdit_group->setText( todolist_n->group[ todolist_nr ] );
	if ( todolist_n->year[todolist_nr] != "" ) QLineEdit_year->setText( todolist_n->year[ todolist_nr ] );
	if ( todolist_n->comment[todolist_nr] != "" ) QLineEdit_comment->setText( todolist_n->comment[ todolist_nr ] );
	if ( todolist_n->album[todolist_nr] != "" ) QLineEdit_album->setText( todolist_n->album[ todolist_nr ] );
	if ( todolist_n->music_type[todolist_nr] == 99 ) todolist_n->music_type[ todolist_nr ] = QComboBoxType->currentItem();
	QComboBoxType->setCurrentItem( todolist_n->music_type[ todolist_nr ] );
	QCheckButton_create_groupdir->setChecked( todolist_n->create_dir_group );
	QCheckButton_create_albumdir->setChecked( todolist_n->create_dir_album );
//	QLineEdit_title->selectAll();

	init = FALSE;
};
void namewidget::save_input()
{
	if ( !init )
	{
		todolist_n->create_dir_group = QCheckButton_create_groupdir->isChecked();
		todolist_n->create_dir_album = QCheckButton_create_albumdir->isChecked();

		todolist_n->group[ todolist_nr ]         = QLineEdit_group->text();
		todolist_n->album[ todolist_nr ]         = QLineEdit_album->text();
		todolist_n->title[ todolist_nr ]         = QLineEdit_title->text();
		todolist_n->year[ todolist_nr ]          = QLineEdit_year->text();
		todolist_n->comment[ todolist_nr ]       = QLineEdit_comment->text();
		todolist_n->music_type[todolist_nr]      = QComboBoxType->currentItem();
	};
};
void namewidget::invokeHelp()
{
	kapp->invokeHTMLHelp("krabber/krabber-3.html#ss3.5", "");
}
void namewidget::finish()
{
	unsigned int i;

	save_input ();
	for ( i = 1; i <= todolist_n->tracks; i++ )
		todolist_n->output_filename[ i ] = update_filename( i );

	emit destroy_namewidget();
};
void namewidget::closeEvent( QCloseEvent *e )
{
	e->accept();
	finish();
};

